/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "SEMod_struct.h"
//#include "SEPin.h"
#include <assert.h>

// define some constants to make referencing in/outs clearer
#define PN_IN1 1
#define PN_OUT1 2
#define PN_PATCH_PARAM 0

void Module::open()
{
//	SET_PROCESS_FUNC(Module::sub_process);

	SEModule_base::open();	// always call the base class
	CallHost(seaudioMasterSleepMode);
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

// describe the pins (plugs and parameters)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )								// !!TODO!! list your in / out plugs
	{
	case 0:
		properties->name				= "Animation Position";
		properties->direction			= DR_IN;
		properties->datatype			= DT_FLOAT;
//		properties->default_value		= "";
		properties->flags				= IO_UI_COMMUNICATION;
		break;
	case 1:
		properties->name				= "List";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_ENUM;
		properties->flags				= IO_UI_COMMUNICATION;
		break;
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}
