/*-----------------------------------------------------------------------------

 2005, Jeff McClintock, SynthEdit 

-----------------------------------------------------------------------------*/
#include "Module.h"
#include "GuiModule.h"
#include "semod_struct.h"

extern "C" {
__declspec (dllexport)
int getModuleProperties(int p_index, SEModuleProperties* properties)
{
	properties->sdk_version = SDK_VERSION;

	switch( p_index )
	{
	case 0:
		{
			// describe the plugin, this is the name the end-user will see.
			properties->name = "OL AP To List2";

			// return a unique string 32 characters max
			// include manufacturer and plugin identity
			// this is used internally by SE to identify the plug.
			// No two plugs may have the same id.
			properties->id = "OL AP To List2 v1.0";

			// Info, may include Author, Web page whatever
			properties->about = "Cycle through a list with a bitmap image\nversion 1.0\nby Oli Larkin\n\nwww.oli.adbe.org";	
			properties->gui_flags = CF_STRUCTURE_VIEW;
		}
		break;
	default:
		return false; // host will ask for module 0,1,2,3 etc. return false to signal when done
	};

	return true;
}
}

extern "C" {
__declspec (dllexport)
void * makeModule(int p_index, int p_type, seaudioMasterCallback2 seaudioMaster, void *p_resvd1)
{
	switch( p_index )								// !!TODO!! list your modules
	{
	case 0:
		{
			if( p_type == 1 ) // Audio Processing Object
			{
				SEModule_base *effect = new Module(seaudioMaster, p_resvd1);
				if (!effect)
					return 0;
				return effect->getAeffect();
			}
			if( p_type == 2 ) // GUI Object
			{
				GuiModule *effect = new GuiModule((seGuiCallback) seaudioMaster, p_resvd1); //nasty!
				if (!effect)
					return 0;
				return effect->getAeffect();
			}
		}
		break;
	};

	return 0;
}
}

#if WIN32
#include <windows.h>
void* hInstance;
BOOL WINAPI DllMain (HINSTANCE hInst, DWORD dwReason, LPVOID lpvReserved)
{
	hInstance = hInst;
	return 1;
}
#endif
